/*
 * File Name: tpstarts.c Please do not edit this file. It was generated using
 * rpcgen.
 * Copyright Software Kinetics Ltd.
 * 
 * Software Kinetics Ltd. has granted a licence of this software to
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve,
 * reproduce and sell the software.
 *
 * The software is provided to the user "as is" without warranty of
 * any kind.  Neither Software Kinetics Ltd. nor the National Library
 * of Canada warrants,guarantees or makes any representation regarding
 * the use, or the results of the use of the software in terms of
 * accuracy,reliability, or otherwise.  The entire risk as results and
 * performance of the software is assumed by the user. Neither
 * Software Kinetics Ltd. nor the National Library of Canada shall be
 * liable for any direct, indirect, consequential or incidental
 * damages arising out the use of software.
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 *
 * $Id: tpstarts.c,v 1.1 1993/11/01 17:03:51 irsuprt Exp irsuprt $
 * $Log: tpstarts.c,v $
 * Revision 1.1  1993/11/01  17:03:51  irsuprt
 * Initial revision
 *
 *
 */

#include <stdio.h>
#include <rpc/rpc.h>
#include "tpstartu.h"
#include <fcntl.h>
#include <pwd.h>
#include <ctype.h>
#include <sys/errno.h>
#include <signal.h>

#define ERROR -1
#define PERMS 0666
extern int errno;
int TCP_PORT_NO;

static void tp_startup_program_1();

tp_death_child_func()
{
    int wpid, status;

    wpid = wait(&status);

#ifdef DEBUG
    if (wpid != 0)
    {
        printf("tp_death_child_func: child process (wpid=%d) has terminated \n", wpid);
    }
    else if (wpid == ERROR && errno != EINTR)
    {
        printf("tp_death_child_func: wait/return error\n");
    }
    else
        printf("tp_death_child_func: wait/return other error\n");
#endif

}

main(argc, argv)
    int argc;
    char *argv[];
{
    register SVCXPRT *transp;

    (void) pmap_unset(TP_STARTUP_PROGRAM, TP_STARTUP_VERS);

    transp = svcudp_create(RPC_ANYSOCK);
    if (transp == NULL)
    {
        printf("cannot create udp service.\n");
        exit(1);
    }
    if (!svc_register(transp, TP_STARTUP_PROGRAM, TP_STARTUP_VERS, tp_startup_program_1, IPPROTO_UDP))
    {
        printf("unable to register (TP_STARTUP_PROGRAM, TP_STARTUP_VERS, udp).\n");
        exit(1);
    }

    transp = svctcp_create(RPC_ANYSOCK, 0, 0);
    if (transp == NULL)
    {
        printf("cannot create tcp service.\n");
        exit(1);
    }
    if (!svc_register(transp, TP_STARTUP_PROGRAM, TP_STARTUP_VERS, tp_startup_program_1, IPPROTO_TCP))
    {
        printf("unable to register (TP_STARTUP_PROGRAM, TP_STARTUP_VERS, tcp).\n");
        exit(1);
    }

    signal(SIGCLD, tp_death_child_func);

    svc_run();
    printf("RPC svc_run returned\n");
    exit(1);
    /* NOTREACHED */
}

static void
tp_startup_program_1(rqstp, transp)
    struct svc_req *rqstp;
    register SVCXPRT *transp;
{
    union
    {
        int fill;
    } argument;
    char *result;
    bool_t(*xdr_argument) (), (*xdr_result) ();
    char *(*local) ();

    switch (rqstp->rq_proc)
    {
        case NULLPROC:
            (void) svc_sendreply(transp, xdr_void, (char *) NULL);
            return;

        case TP_STARTUP:
            xdr_argument = xdr_void;
            xdr_result = xdr_int;
            local = (char *(*) ()) tp_startup_1;
            break;

        default:
            svcerr_noproc(transp);
            return;
    }
    bzero((char *) &argument, sizeof(argument));
    if (!svc_getargs(transp, xdr_argument, &argument))
    {
        svcerr_decode(transp);
        return;
    }
    result = (*local) (&argument, rqstp);
    if (result != NULL && !svc_sendreply(transp, xdr_result, result))
    {
        svcerr_systemerr(transp);
    }
    if (!svc_freeargs(transp, xdr_argument, &argument))
    {
        printf("unable to free arguments\n");
        exit(1);
    }
    return;
}
